<?php
/* **************************************************************************** *

 * cor-log-in.php								*
 * @package	Core								*
 * @copyright	Copyright (c) 2008 Martin Novák. All rights reserved		*
 * @license	GNU/AGPL http://www.gnu.org/licenses/agpl.html			*

 * Albireo is free software! You can redistribute it and/or modify it under	*
 * the terms of the GNU Affero General Public License as published		*
 * by the Free Software Foundation, either version 3 of the License, or		*
 * (at your option) any later version.						*

 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the		*
 *	GNU Affero General Public License for more details.			*

 This script description:
 Script for managing logins into administration of Albireo.

 Properties:
    array $page			// contains changes for array $page in ScriptPage
 	
 Public Methods:
    none
 	
 * **************************************************************************** */

class LogIn {

    public $page = array ( "text" => "" );

    public function __construct ()
    {

        if ( !isset ( $_SERVER [ "HTTPS" ] ) ) {
            $address = "https://". $_SERVER [ "HTTP_HOST" ] . substr ( $_SERVER [ "SCRIPT_NAME" ], 0, strrpos ( $_SERVER [ "SCRIPT_NAME" ], "/" ) ) ."/". Tools::getFullPage ();
            $curl = new Curl ();
            $webpage = $curl -> get ( $address );
            if ( strlen ( $webpage ) > 1 ) {
                header ( "Location:". $address );
            }
        }
    
    	if ( AlbireoUser::isLogedIn () ) {
    	    header ( "Location:". Localization::session () -> getFile ( "cor-overview" ) );
    	}
    	if ( isset ( $_POST [ "h-login" ], $_POST [ "j-login" ] ) ) {
    	    $this -> page [ "text" ] .= AlbireoUser::login ( $_POST [ "j-login" ], $_POST [ "h-login" ] );
    	}
        if ( isset ( $_POST [ "openid" ] ) ) {
            $openid = new OpenId ();
            $openid -> SetIdentity ( $_POST [ "openid" ] );
            $openid -> SetTrustRoot ( "http://" . $_SERVER [ "HTTP_HOST" ] );
            if ( $openid -> GetOpenIDServer () ) {
                $openid -> SetApprovedURL ( "http://" . $_SERVER [ "HTTP_HOST" ] . substr ( $_SERVER [ "SCRIPT_NAME" ], 0, strrpos ( $_SERVER [ "SCRIPT_NAME" ], "/" ) ) ."/". Tools::getFullPage () );
                $openid -> Redirect ();
            } else {
                $error = $openid -> GetError ();
                $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Přihlášení pomocí OpenID selhalo:" )." ".$error [ "code" ]." - ".$error [ "description" ]."</strong></p>";
            }
        }
        if ( isset ( $_GET [ "openid_mode" ] ) && $_GET [ "openid_mode" ] == "id_res" ) {
            $openid = new OpenId();
            $openid -> SetIdentity ( urldecode ( $_GET [ "openid_identity" ] ) );
            if ( $openid -> ValidateWithServer () == true ) {
                $this -> page [ "text" ] .= AlbireoUser::openIdLogin ( $openid -> GetIdentity() );
            } elseif ( $openid -> IsError () == true ) {
                $error = $openid -> GetError ();
                $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Přihlášení pomocí OpenID selhalo:" )." ".$error [ "code" ]." - ".$error [ "description" ]."</strong></p>";
            }
        } elseif ( isset ( $_GET [ "openid_mode" ] ) && $_GET [ "openid_mode" ] == "cancel" ){
            $this -> page [ "text" ] .= '<p><strong class="warning">'._( "Uživatel zrušil přihlašování." ).'</strong></p>';
        }

    	$this -> page [ "text" ] .= Database::connection () -> getResult ( "SELECT text FROM content WHERE id_header=(SELECT id FROM header WHERE file='". Tools::getPage () ."');" );
    	$this -> page [ "text" ] .= '<script type="text/javascript" src="scripts/cor-form-default-text.js"></script>
            <hr class="cleaner" />
            <div id="loginforms">
    	    <form action="'. Tools::getFullPage () . ( empty ( $_GET [ "loginpage" ] ) ? "" : "?loginpage=". $_GET [ "loginpage" ] ) .'" method="post" enctype="application/x-www-form-urlencoded" id="albireologin">
     	    	<fieldset>
                    <legend>'. _( "Přihlášení pomocí účtu Albirea" ) .'</legend>
                    <img class="objectLeft" src="styles/cor-admin/albireo-small.jpg" alt="albireo" />
     	    	    <label for="j-login">'. _( "Jméno" ) .': </label><input type="text" size="15" id="j-login" name="j-login" maxlength="20" value="'. _( "Přezdívka" ) .'" onfocus="onFocusFormDefaultText(\''. _( "Přezdívka" ) .'\',this);" onblur="onLostFocusFormDefaultText(\''. _( "Přezdívka" ) .'\',this);" /><br />
             	    <label for="h-login">'. _( "Heslo" ) .': </label><input type="password" size="15" id="h-login" name="h-login" maxlength="25" value="Heslo" onfocus="onFocusFormDefaultText(\'Heslo\',this);" onblur="onLostFocusFormDefaultText(\'Heslo\',this);" /><br />
             	    <br /><input type="submit" value="'. _( "přihlásit" ) .'" />
             	</fieldset>
     	    </form>
            <form action="'. Tools::getFullPage () . ( empty ( $_GET [ "loginpage" ] ) ? "" : "?loginpage=". $_GET [ "loginpage" ] ) .'" method="post" enctype="application/x-www-form-urlencoded" id="openidlogin">
     	    	<fieldset>
                    <legend>'. _( "Přihlášení s OpenID" ) .'</legend>
                    <img class="objectLeft" src="styles/cor-admin/openid.gif" alt="openid" />
                    <label for="openid">'. _( "Vaše OpenID" ) .': </label><input type="text" size="15" id="openid" name="openid" value="'. _( "Vaše OpenID" ) .'" onfocus="onFocusFormDefaultText(\''. _( "Vaše OpenID" ) .'\',this);" onblur="onLostFocusFormDefaultText(\''. _( "Vaše OpenID" ) .'\',this);" /><br />
             	    <br /><input type="submit" value="'. _( "přihlásit" ) .'" />
                    <br /><br /><a href="http://www.openid.cz/">'. _( "Získejte OpenID" ) .'</a>
                </fieldset>
            </form>
            </div>

            <a href="#" id="openidopen"><img src="styles/cor-admin/openid.gif" height="20px" alt="openid" /> Přihlašte se pomocí OpenID</a>
            <a href="#" id="albireoopen"><img src="styles/cor-admin/albireo-small.jpg" height="20px" alt="albireo" /> Přihlašte se pomocí uživatelského účtu</a>
            <script type="text/javascript">
                var cookiedays = 14;
                var date = new Date();
                date.setTime(date.getTime() + 1000 * 60 * 60 * 24 * cookiedays);
                function cookieValue ( cookieName ){
                    cookies = document.cookie.split(";");
                    for (i in cookies){
                        oneCookie = cookies[i].split("=");
                        if (oneCookie[0] == cookieName) cookieValue=oneCookie[1];
                            return cookieValue;
                    }
                }
                function openOpenID () {
                    $("#albireologin").animate({left:"-600px"},500);
                    $("#openidlogin").css("top","-"+$("#albireologin").height()+"px");
                    $("#openidlogin").css("left","600px");
                    $("#openidlogin").animate({left:"0px"},500);
                    $("#openidopen").css("display","none");
                    $("#albireoopen").css("display","inline");
                    document.cookie = "loginmethod=openid;expires=" + date.toGMTString();
                }
                $("#openidopen").click(function () {
                    openOpenID ();
                    return false;
                });
                $("#albireoopen").click(function () {
                    $("#openidlogin").animate({left:"600px"},500,0,function () {
                        $("#openidlogin").css("top","0px");
                        $("#openidlogin").css("left","0px");
                    });
                    $("#albireologin").animate({left:"0px"},500);
                    $("#albireoopen").css("display","none");
                    $("#openidopen").css("display","inline");
                    document.cookie = "loginmethod=useraccount;expires=" + date.toGMTString();
                    return false;
                });
                $(document).ready(function () {
                    $("#loginforms").css("width","430px");
                    $("#loginforms").css("height","120px");
                    $("#loginforms").css("margin","0px auto");
                    $("#loginforms").css("overflow","hidden");
                    $("#albireologin").css("position","relative");
                    $("#albireologin").css("float","left");
                    $("#albireologin>fieldset").css("border","none");
                    $("#albireologin").css("width","430px");
                    $("#albireologin").css("height","120px");
                    $("#openidlogin").css("position","relative");
                    $("#openidlogin").css("float","left");
                    $("#openidlogin>fieldset").css("border","none");
                    $("#openidlogin").css("width","430px");
                    $("#openidlogin").css("height","120px");
                    $("#albireoopen").css("display","none");
                    if (cookieValue("loginmethod")=="openid") {
                        openOpenID ();
                    }
                });
            </script>';
        if ( isset ( $_SERVER [ "HTTPS" ] ) ) {
            $this -> page [ "text" ] .= '<div><strong class="success">'. _( "Albireo je nastaveno na šifrovaný přístup k administraci." ) .'</strong></div>';
        }
    } // end __construct

}

$LogIn = new LogIn ();
$page = $LogIn -> page;
?>